VTK: vtkDGTet Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Member Functions | List of all members
vtkDGTet Class Reference

Metadata for a discontinuous Galerkin tetrahedron. More...

`#include <vtkDGTet.h>`

Inheritance diagram for vtkDGTet:
[legend]
Collaboration diagram for vtkDGTet:
[legend]

## Public Types
using | CellTypeId = std::size_t
using | DOFType = vtkStringToken
typedef vtkDGCell | Superclass
Public Types inherited from vtkDGCell
enum | Shape : int { Vertex , Edge , Triangle , Quadrilateral , Tetrahedron , Hexahedron , Wedge , Pyramid }
| All possible shapes for DG cells. More...
typedef vtkCellMetadata | Superclass
Public Types inherited from vtkCellMetadata
using | CellTypeId = vtkStringToken::Hash
using | DOFType = vtkStringToken
using | MetadataConstructor = std::function< vtkSmartPointer< vtkCellMetadata >(vtkCellGrid *)>
using | ConstructorMap = std::unordered_map< vtkStringToken, MetadataConstructor >
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkDGTet * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
vtkIdType | GetNumberOfCells () override
| Return the number of cells of this type in the parent cell-grid object. More...
Shape | GetShape () const override
| Return the topological shape of this cell type. More...
int | GetDimension () const override
| Return the parametric dimension of this cell type (0, 1, 2, or 3). More...
int | GetNumberOfCorners () const override
| Return the number of corner points for this cell type. More...
const std::array< double, 3 > & | GetCornerParameter (int corner) const override
| Return the coordinates of the reference element's corner vertex. More...
int | GetNumberOfSideTypes () const override
| Return the number of different side shapes of this cell type. More...
std::pair< int, int > | GetSideRangeForType (int sideType) const override
| Return the range of sides of the ii-th type, where ii is in [0, this->GetNumberOfSideTypes()[. More...
int | GetNumberOfSidesOfDimension (int dimension) const override
| Return the number of boundaries this type of cell has of a given dimension. More...
const std::vector< vtkIdType > & | GetSideConnectivity (int side) const override
| Return the connectivity of the given side. More...
Shape | GetSideShape (int side) const override
| For a given side, return its cell shape. More...
vtkTypeFloat32Array * | GetReferencePoints () const override
| Return a singleton array initialized with the reference-cell's corner point coordinates. More...
vtkTypeInt32Array * | GetSideConnectivity () const override
| Return a singleton array initialized with point-ids of each side's corners. More...
vtkTypeInt32Array * | GetSideOffsetsAndShapes () const override
| Return a singleton array initialized with 2-tuples of (offset, shape) values. More...
Public Member Functions inherited from vtkDGCell
vtkDGCell * | NewInstance () const
void | FillReferencePoints (vtkTypeFloat32Array *arr) const
| Fill the passed array with the parametric coordinates of all the element's corners. More...
void | FillSideConnectivity (vtkTypeInt32Array *arr) const
| Fill the passed array with the connectivity (point IDs) of all the element's sides. More...
void | FillSideOffsetsAndShapes (vtkTypeInt32Array *arr) const
| Fill the passed array with tuples of (1) offsets into the side-connectivity and (2) shapes for each type of side. More...
Public Member Functions inherited from vtkCellMetadata
vtkCellMetadata * | NewInstance () const
CellTypeId | Hash ()
| Return a hash of the cell type. More...
virtual bool | SetCellGrid (vtkCellGrid *parent)
| Set the vtkCellGrid holding DOF arrays required by this cell. More...
virtual vtkCellGrid * | GetCellGrid ()
| Return the parent vtkCellGrid that owns this instance (or nullptr). More...
bool | Query (vtkCellGridQuery *query)
| Respond to a query on cells of this type. More...
virtual void | ShallowCopy (vtkCellMetadata *vtkNotUsed(other))
| Copy other into this instance (which must be of the same type). More...
virtual void | DeepCopy (vtkCellMetadata *vtkNotUsed(other))
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkDGTet * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkDGTet * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkDGCell
static vtkTypeBool | IsTypeOf (const char *type)
static vtkDGCell * | SafeDownCast (vtkObjectBase *o)
static int | GetShapeCornerCount (Shape shape)
static int | GetShapeDimension (Shape shape)
static vtkStringToken | GetShapeName (Shape shape)
Static Public Member Functions inherited from vtkCellMetadata
static vtkTypeBool | IsTypeOf (const char *type)
static vtkCellMetadata * | SafeDownCast (vtkObjectBase *o)
template<typename Subclass >
static bool | RegisterType ()
| Register a subclass of vtkCellMetadata. More...
template<typename Subclass >
static vtkSmartPointer< Subclass > | NewInstance (vtkCellGrid *grid=nullptr)
static vtkSmartPointer< vtkCellMetadata > | NewInstance (vtkStringToken className, vtkCellGrid *grid=nullptr)
static vtkCellGridResponders * | GetResponders ()
| Return the set of registered responder types. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Static Public Attributes
static constexpr int | Dimension = 3
static const std::array< std::array< double, 3 >, 4 > | Parameters
static const std::array< std::vector< vtkIdType >, 14 > | Sides
static const std::array< int, vtkDGTet::Dimension+1 > | SideOffsets
static const std::array< Shape, Dimension+1 > | SideShapes

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkDGTet ()
| ~vtkDGTet () override
Protected Member Functions inherited from vtkDGCell
| vtkDGCell ()
| ~vtkDGCell () override
Protected Member Functions inherited from vtkCellMetadata
| vtkCellMetadata ()=default
| ~vtkCellMetadata () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()
Protected Attributes inherited from vtkCellMetadata
vtkCellGrid * | CellGrid { nullptr }
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
Static Protected Attributes inherited from vtkCellMetadata
static ConstructorMap | Constructors
static vtkNew< vtkCellGridResponders > | Responders

## Detailed Description

Metadata for a discontinuous Galerkin tetrahedron.

Currently, only a linear shape is supported but this may change to arbitrary order.

Tests:
  vtkDGTet (Tests)

Definition at line 27 of file vtkDGTet.h.

## Member Typedef Documentation

## ◆ CellTypeId

using vtkDGTet::CellTypeId = std::size_t

Definition at line 30 of file vtkDGTet.h.

## ◆ DOFType

using vtkDGTet::DOFType = vtkStringToken

Definition at line 31 of file vtkDGTet.h.

## ◆ Superclass

typedef vtkDGCell vtkDGTet::Superclass

Definition at line 34 of file vtkDGTet.h.

## Constructor & Destructor Documentation

## ◆ vtkDGTet()

vtkDGTet::vtkDGTet | ( |  | ) |
| protected

## ◆ ~vtkDGTet()

vtkDGTet::~vtkDGTet | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkDGTet* vtkDGTet::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkDGTet::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkDGTet::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkDGCell.

## ◆ SafeDownCast()

static vtkDGTet* vtkDGTet::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkDGTet::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkDGCell.

## ◆ NewInstance()

vtkDGTet* vtkDGTet::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkDGTet::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkDGCell.

## ◆ GetNumberOfCells()

vtkIdType vtkDGTet::GetNumberOfCells | ( |  | ) |
| overridevirtual

Return the number of cells of this type in the parent cell-grid object.

Subclasses must override this method.

Reimplemented from vtkCellMetadata.

## ◆ GetShape()

Shape vtkDGTet::GetShape | ( |  | ) | const
| inlineoverridevirtual

Return the topological shape of this cell type.

Implements vtkDGCell.

Definition at line 39 of file vtkDGTet.h.

## ◆ GetDimension()

int vtkDGTet::GetDimension | ( |  | ) | const
| inlineoverridevirtual

Return the parametric dimension of this cell type (0, 1, 2, or 3).

Reimplemented from vtkDGCell.

Definition at line 40 of file vtkDGTet.h.

## ◆ GetNumberOfCorners()

int vtkDGTet::GetNumberOfCorners | ( |  | ) | const
| inlineoverridevirtual

Return the number of corner points for this cell type.

Reimplemented from vtkDGCell.

Definition at line 41 of file vtkDGTet.h.

## ◆ GetCornerParameter()

const std::array<double, 3>& vtkDGTet::GetCornerParameter | ( | int | corner | ) | const
| overridevirtual

Return the coordinates of the reference element's corner vertex.

Any well-formed element in world coordinates can be mapped to its reference element by transforming its corner points to these; this mapping is frequently used to visualize and analyze elements.

Implements vtkDGCell.

## ◆ GetNumberOfSideTypes()

int vtkDGTet::GetNumberOfSideTypes | ( |  | ) | const
| overridevirtual

Return the number of different side shapes of this cell type.

Example: a wedge has 4 side shapes: Quadrilateral, Triangle, Edge, and Vertex.

Implements vtkDGCell.

## ◆ GetSideRangeForType()

std::pair<int, int> vtkDGTet::GetSideRangeForType | ( | int | sideType | ) | const
| overridevirtual

Return the range of sides of the ii-th type, where ii is in [0, this->GetNumberOfSideTypes()[.

If you pass ii = -1, this will return the total number of sides of all types.

The returned pair of integers is a half-open interval of side IDs. The difference between the returned values is the number of sides of sideType.

Example: a tetrahedron will return the following:

- for sideType 0 (faces): [0, 4[
- for sideType 1 (edges): [4, 10[
- for sideType 2 (verts): [10, 14[
- for sideType -1 (all): [0, 14[

Implements vtkDGCell.

## ◆ GetNumberOfSidesOfDimension()

int vtkDGTet::GetNumberOfSidesOfDimension | ( | int | dimension | ) | const
| overridevirtual

Return the number of boundaries this type of cell has of a given dimension.

DG cells can be thought of as CW-complex cells; they are tuples of corner points which represent an open point set plus its closure decomposed into a union of open sets of lower dimension. For example, a hexahedron is an 8-tuple of corner points representing an underlying space shaped as an open, rectangular prism plus six 4-tuples representing its quadrilateral faces, plus twelve 2-tuples representing its edges, plus 8 1-tuples representing its corners. Thus, a hexahedron has 6 + 12 + 8 = 26 sides (plus its interior).

Implements vtkDGCell.

## ◆ GetSideConnectivity() [1/2]

const std::vector<vtkIdType>& vtkDGTet::GetSideConnectivity | ( | int | side | ) | const
| overridevirtual

Return the connectivity of the given side.

The side connectivity is a vector holding the indexes of corner-points of the side into the connectivity vector of this cell.

Passing a side of -1 should return the connectivity of the cell's interior (a vector of the counting numbers from 0 to this->GetNumberOfCorners()). This feature is used when rendering cells of dimension 2 or lower.

Implements vtkDGCell.

## ◆ GetSideShape()

Shape vtkDGTet::GetSideShape | ( | int | side | ) | const
| overridevirtual

For a given side, return its cell shape.

The sides of a vtkDGCell are always ordered from highest dimension to lowest. For example, a hexahedron's quadrilateral sides are numbered 0–5, its line sides are numbered 6–17, and its corner point sides are numbered 18–25. Sometimes, the interior of the element is considered a side labeled -1.

Implements vtkDGCell.

## ◆ GetReferencePoints()

vtkTypeFloat32Array* vtkDGTet::GetReferencePoints | ( |  | ) | const
| overridevirtual

Return a singleton array initialized with the reference-cell's corner point coordinates.

When implementing a subclass, call FillReferencePoints() in your override. This should always return the same vtkTypeFloat32Array each time so that the array is only uploaded to the GPU once.

Implements vtkDGCell.

## ◆ GetSideConnectivity() [2/2]

vtkTypeInt32Array* vtkDGTet::GetSideConnectivity | ( |  | ) | const
| overridevirtual

Return a singleton array initialized with point-ids of each side's corners.

To make use of this array, you should also call GetSideOffsetsAndShapes() and GetShapeCornerCount().

When implementing a subclass, call FillSideConnectivity() in your override. This should always return the same vtkTypeInt32Array each time so that the array is only uploaded to the GPU once.

Implements vtkDGCell.

## ◆ GetSideOffsetsAndShapes()

vtkTypeInt32Array* vtkDGTet::GetSideOffsetsAndShapes | ( |  | ) | const
| overridevirtual

Return a singleton array initialized with 2-tuples of (offset, shape) values.

When implementing a subclass, call FillSideOffsetsAndShapes() in your override. This should always return the same vtkTypeInt32Array each time so that the array is only uploaded to the GPU once.

Implements vtkDGCell.

## Member Data Documentation

## ◆ Dimension

constexpr int vtkDGTet::Dimension = 3
| staticconstexpr

Definition at line 53 of file vtkDGTet.h.

## ◆ Parameters

const std::array<std::array<double, 3>, 4> vtkDGTet::Parameters
| static

Definition at line 54 of file vtkDGTet.h.

## ◆ Sides

const std::array<std::vector<vtkIdType>, 14> vtkDGTet::Sides
| static

Definition at line 55 of file vtkDGTet.h.

## ◆ SideOffsets

const std::array<int, vtkDGTet::Dimension + 1> vtkDGTet::SideOffsets
| static

Definition at line 56 of file vtkDGTet.h.

## ◆ SideShapes

const std::array<Shape, Dimension + 1> vtkDGTet::SideShapes
| static

Definition at line 57 of file vtkDGTet.h.

The documentation for this class was generated from the following file:

- Filters/CellGrid/vtkDGTet.h